/*-------------------------------------------------------------------------+
| Copyright 2021 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.ext.reuse.storage;

import static org.fortiss.tooling.ext.reuse.storage.ReuseLibraryStorageManager.AF3_REUSE_LIBRARY_FILES_EXTENSION;

import org.eclipse.core.resources.IFile;
import org.fortiss.tooling.kernel.extension.IEclipseResourceStorageLocationProvider;

/**
 * An {@link IEclipseResourceStorageLocationProvider} for model files with the
 * reuse extension (currently <I>.af3_rlib</I>).
 *
 * @author bergemann
 */
public final class ReuseLibraryLocationProvider implements IEclipseResourceStorageLocationProvider {

	/** {@inheritDoc} */
	@Override
	public boolean isStorageLocation(IFile file) {
		return file.getFileExtension().equals(AF3_REUSE_LIBRARY_FILES_EXTENSION);
	}
}
