/*-------------------------------------------------------------------------+
| Copyright 2022 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.ext.variability.analysis;

import static org.fortiss.tooling.ext.variability.util.VariabilityUtils.calculateGlobalPresenceCondition;

import org.eclipse.emf.ecore.EObject;
import org.fortiss.tooling.base.model.element.IModelElementSpecification;
import org.fortiss.variability.analysis.GenericProductLineTranslation;
import org.fortiss.variability.model.presence.PresenceConditionTerm;

/**
 * Adjusts the generic implementation of the translation to the variation point translation with
 * {@link IModelElementSpecification}s.
 * 
 * @deprecated
 * 
 * @author bayha
 */
public class ProductLineTranslationBase extends GenericProductLineTranslation {

	/** {@inheritDoc} */
	@Override
	protected PresenceConditionTerm getGlobalPresenceConditionForEObject(EObject eo) {
		return calculateGlobalPresenceCondition(eo);
	}
}
